#ifndef _SPECIFIC_COMM_H_
#define _SPECIFIC_COMM_H_ 1

/* Non standard include */
#include <commtech.h>

#define SHARED_SPACE_SIZE (2 * BUF_SIZE)
#define SHARED_SPACE_VOIDPTR (SHARED_SPACE_SIZE / sizeof(void *))

struct comm
{
	void * volatile *shared_space;
	volatile int cons_idx __attribute__ ((aligned (CACHE_LINE_SIZE)));
	volatile int prod_idx __attribute__ ((aligned (CACHE_LINE_SIZE)));
};


__BEGIN_DECLS

extern __thread struct comm *comm;

static inline void send(void **addr)
{
	static __thread int local_cons_idx = 0;
	int local_prod, next_prod;

	local_prod = comm->prod_idx;
	next_prod = (local_prod + 1) % SHARED_SPACE_VOIDPTR;
	if (next_prod == local_cons_idx)
	{
		while (next_prod == comm->cons_idx);
		local_cons_idx = comm->cons_idx;
	}
	comm->shared_space[local_prod] = addr;
	comm->prod_idx = next_prod;
}

__END_DECLS

#endif
